/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ComMainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
	ComPort->LoadSettings(stIniFile, "c:\\testcomport.ini");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Button_OpenClick(TObject *Sender)
{
  if (ComPort->Connected)
    ComPort->Close();
  else
    ComPort->Open();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button_SettingsClick(TObject *Sender)
{
  ComPort->ShowSetupDialog();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button_SendClick(TObject *Sender)
{
__int8 code;
double data;
 try
	{
		data= StrToFloat( Edit_Data->Text);
	}
	catch (Exception &exception)
	{
		Application->MessageBox( "Valeur non valide, entrez un nombre entre -1500 et 1500",
												"Erreur", MB_OK |MB_ICONSTOP);
		LabelSent0->Caption="none";
		LabelSent1->Caption="";
		LabelSent2->Caption="";
		return;
	}
	if (data>2047 || data<-2048)
				{ Application->MessageBox( "Valeur non valide, entrez un nombre entre -2048 et 2047",
																	"Erreur de valeur", MB_OK |MB_ICONSTOP);
					LabelSent0->Caption="none";
					LabelSent1->Caption="";
					LabelSent2->Caption="";
					return;
					}
	SBreference->Position=data*4;
	if (RadioGroupMode->ItemIndex==0)	code=ID_ModeControleVitesse;
				else		 code=ID_ModeControlePosition;
	EnvoieSemiWord(code, data);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComPortOpen(TObject *Sender)
{
  Button_Open->Caption = "Close";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComPortClose(TObject *Sender)
{
  Button_Open->Caption = "Open";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComPortRxChar(TObject *Sender, int Count)
{
  AnsiString Str;
	ComPort->ReadStr(Str, Count);
	Memo->Lines->Add( "reu:"+Str+'\0');
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Bt_LoadClick(TObject *Sender)
{
//	ComPort->LoadSettings(stRegistry, "HKEY_LOCAL_MACHINE\Software\Dejan");
	ComPort->LoadSettings(stIniFile, "c:\\testcomport.ini");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Bt_StoreClick(TObject *Sender)
{
//	ComPort->StoreSettings(stRegistry, "HKEY_LOCAL_MACHINE\Software\Dejan");
	ComPort->StoreSettings(stIniFile, "c:\\testcomport.ini");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
if (ComPort->Connected) 	ComPort->Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ButtonResetClick(TObject *Sender)
{
__int8 code;
double data=0;
	Edit_Data->Text=data;
	SBreference->Position=data*4;
	if (RadioGroupMode->ItemIndex==0)	code=ID_ModeControleVitesse;
				else		 code=ID_ModeControlePosition;
	EnvoieSemiWord(code, data);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EnvoieSemiWord(__int8 code, double data)
{
char Out[4];
AnsiString SS;
int WrittenCount;
__int16 idata;        // donne sur 16 bits signs dont 14 sont significatifs et 2 de controle =0
	idata=data*4;
	Out[0]=code;
	Out[1]=idata & 0x7F;    // sur 7 bits seulement
	Out[2]=(idata>>7) & 0x7F;
	Out[4]=0;
	// pas besoin du dummy char car le PPC aura int sur 1 byte reu  ---	Out[3]=13;
	if (ComPort->Connected)
						{
 //						ComPort->WriteStr(Out);
						WrittenCount=ComPort->Write(Out, 3);
						if (WrittenCount!=3) 	Application->MessageBox( "3 bytes non ecrits !", "Erreur", MB_OK |MB_ICONSTOP);
						Memo->Lines->Add(AnsiString(Out));
						LabelSent0->Caption=SS.sprintf("%03d",UINT8(Out[0]))+" : 0x"+IntToHex(UINT8(Out[0]),2)+" : c"+Out[0];
						LabelSent1->Caption=SS.sprintf("%03d",UINT8(Out[1]))+" : 0x"+IntToHex(UINT8(Out[1]),2)+" : c"+Out[1];
						LabelSent2->Caption=SS.sprintf("%03d",UINT8(Out[2]))+" : 0x"+IntToHex(UINT8(Out[2]),2)+" : c"+Out[2];
						}
		else   {
						Application->MessageBox( "Port Com non ouvert", "Erreur", MB_OK |MB_ICONSTOP);
						LabelSent0->Caption="none";
						LabelSent1->Caption="";
						LabelSent2->Caption="";
						}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SBreferenceScroll(TObject *Sender,
															TScrollCode ScrollCode, int &ScrollPos)
{
__int8 code;
double data=SBreference->Position/4;
	if (RadioGroupMode->ItemIndex==0)	code=ID_ModeControleVitesse;
				else		 code=ID_ModeControlePosition;
	Edit_Data->Text=data;
	EnvoieSemiWord(code, data);
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::RadioGroupModeClick(TObject *Sender)
{
double data;
	if (RadioGroupMode->ItemIndex==0)	data=0;
				else		 data=1;
	EnvoieSemiWord(ID_ModeControle, data);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button1Click(TObject *Sender)
{
	Memo->Text="";	
}
//---------------------------------------------------------------------------

